%-----------------------------------------
% FDLIB
%
% Copyright by C. Pozrikidis, 1999
% All rights reserved.
%
% This program is to be used only under the
% stipulations of the licensing agreement.
%----------------------------------------

%------------------------------------------------
% This program accompanies the book:
%             C. Pozrikidis
% Numerical Computation in Science and Engineering
%        Oxford University Press
%------------------------------------------------

%-----------------------------------------
% Driver for generating a linear system
% for the finite-difference solution
% of the Poisson equation lapl(f)+g = 0,
% as discussed in the text
%-----------------------------------------

clear all
close all

%---
% input
%---

 ax = 0.0;
 bx = 1.0;
 ay = 0.0;
 by = 1.0;

 Nx = 4;
 Ny = 4;

%--------------------
% boundary conditions
% and source term
%--------------------

  for j=1:Ny+1
       w(j) = 0.0D0;  % example
       q(j) = 1.0D0;  % example
  end

  for i=1:Nx+1
       z(i) = 0.0D0;  % example
       v(i) = 0.0D0;  % example
  end

  for i=1:Nx+1
    for j=1:Ny+1
        g(i,j) = 0.0D0; % example
    end
  end

%---------------------------
% generate the linear system
%---------------------------

  [mats,mat,rhs] = pois_fds_DNDD  ...
             ...
   (ax,bx ...
   ,ay,by ...
   ,Nx,Ny ...
   ,g ...
   ,w,q,z,v ...
   );

%-----------------
% printing session
%-----------------

     mat
