      program prd_2d_pr_hs_dr

c========================================
c FDLIB, BEMLIB
c
c Copyright by C. Pozrikidis, 1999
c All rights reserved
c
c This program is to be used only under the
c stipulations of the licencing agreement
c========================================

c-------------------------------
c  Driver for node
c  redistribution along a periodic line
c  along the x-axis
c
c  The line is symmetric with respect to the middle point
c--------------------------

      Implicit Double Precision (a-h,o-z)

      Dimension  X(0:200), Y(0:200)
      Dimension P1(0:200),P2(0:200),P3(0:200)
      Dimension P4(0:200),P5(0:200)

      Dimension XC (200),YC (200),R  (200),S  (200)
      Dimension TH1(200),TH2(200),TH3(200),ORNT(200)

      common/XXYY/X,Y
      common/ARCC/XC,YC,R,S,TH1,TH2,TH3,ORNT

c---
c constants
c---

      pi  = 3.14159 265358 979323 84D0
      pih = 0.5D0*pi
      pi2 = 2.0D0*pi
      pi4 = 4.0D0*pi
      pi8 = 8.0D0*pi

      Null = 0

c---
c input parameters
c---

c---
c input parameters
c---

      open (1,file="prd_2d_pr_hs.dat",status="unknown")

       read (1,*) thmax
       read (1,*) spmin
       read (1,*) spmax
       read (1,*) thrs1,thrs2

      close (1)

      write (6,*)
      write (6,*) ' Enter:'
      write (6,*)
      write (6,*) ' 1 to generate a periodic shape '
      write (6,*) ' 2 to read it from file prd_2d_pr_hs.inp'
      write (6,*) ' 0 to quit'
      write (6,*) ' ---------'
      read  (5,*) Iread

      if(Iread.eq.0) Go to 99

c---
c prepare
c---

      thmax = thmax*pi
      thrs1 = thrs1*RL
      thrs2 = thrs2*RL

      open (2,file="prd_2d_pr_hs.out",status="unknown")

c------------------------------
c generate primary distribution
c------------------------------

      if(Iread.eq.1) Then

      write (6,*) 
      write (6,*) ' Enter the period: L '
      write (6,*) ' (try 1.0)'
      write (6,*) ' ---------'
      read  (5,*)   RL

      write (6,*) 
      write (6,*) ' Will generate a sinusoidal shape'
      write (6,*) ' with two waves'
      write (6,*) 
      write (6,*) ' Enter the amplitudes a0 and a1'
      write (6,*) ' (try 0.1, 0.1)'
      write (6,*) ' --------------'
      read  (5,*)  a0,a1

      write (6,*)
      write (6,*) ' Enter the number of points'
      write (6,*) ' must be even and less than 198'
      write (6,*) ' (try 32)'
      write (6,*) ' --------'
      read  (5,*)   NSG

      NSGM = NSG/2+1
      NSG1 = NSG+1
      NSG2 = NSG+2

      step = 1.0/(NSG1-1.0)

      Do i=1,NSGM

        arg   = (i-1.0)*step
        argu  = arg*pi2
        X(i)  = (arg+0.01*sin(argu))*RL
        tmp   = X(i)*pi2/RL
        Y(i)  = a0*cos(tmp) + a1*cos(2.0*tmp)

      End Do

      write (6,104) 

c---
      else    ! read the primary distribution
c---

      open (8,file="prd_2d_pr_hs.inp",status="unknown")

        read (8,*) NSGM

        Do i=1,NSGM
         read (8,*) idle,X(i),Y(i)
        End Do

          RL = 2.0D0*(X(NSGM)-X(1))
         NSG = 2*(NSGM-1)
        NSG1 = NSG+1
        NSG2 = NSG+2

      close (8)

c---
      end if
c---

c-----------------
c printing session
c-----------------

      write (6,*)
      write (6,*)  " Primary distribution:"
      write (6,*)
      write (2,104) NSGM

      Do i=1,NSGM
        write (2,104) i,X(i),Y(i)
        write (6,104) i,X(i),Y(i)
      End Do

c---------------
c redistribution
c---------------

      ICH1 = 1    ! all checks enabled
      ICH2 = 1
      ICH3 = 1
      ICH4 = 1

      call prd_2d_pr_hs 
     +
     +   (NSG
     +   ,RL
     +   ,ICH1,thmax
     +   ,ICH2,spmax
     +   ,ICH3,spmin
     +   ,ICH4,thrs1,thrs2
     +   ,Arcl,Area
     +   ,Centx,Centy
     +   ,P1,P2,P3
     +   ,P4,P5
     +   ,Istop
     +   )

      NSGM = NSG/2+1

c----------------------------------
c printing the revised distribution
c----------------------------------

      write (6,*)
      write (6,*)  " Revised distribution:"
      write (6,*)
      write (2,104) NSGM

      Do i=1,NSGM
        write (2,104) i,X(i),Y(i)
        write (6,104) i,X(i),Y(i)
      End Do

c---
c done
c---

      write (2,104) Null
      close (2)

  99  Continue

 104  Format (1X,I3,1X,F12.8,1X,F12.8,1X,I1)

      Stop
      End
