      subroutine rec_2d_int
     +
     +  (ax,bx
     +  ,ay,by
     +  ,Nx,Ny
     +  ,x,y
     +  ,vux,vuy
     +  )

c------------------------------
c Bilinear interpolation of the velocity
c at the point (x, y)
c-------------------------------

      Dimension glx(129), gly(129)

      Dimension  gx(129,129), gy(129,129)
      Dimension gux(129,129),guy(129,129)

c---
c common blocks
c---

      common/grid_2d_1/glx,gly
      common/grid_2d_2/gx,gy
      common/grid_2d_3/gux,guy

c---------------------
c locate the x-interval
c----------------------

      Do i=1,Nx
       prod = (x-glx(i))*(x-glx(i+1))
       If(prod.lt.0) Go to 1
      End Do

  1   kx = i

c----------------------
c locate the y-interval
c----------------------

      Do j=1,Ny
       prod = (y-gly(j))*(y-gly(j+1))
       If(prod.lt.0) Go to 2
      End Do

  2   ky = j

c----------------------
c interpolation weights
c----------------------

      A00 = (glx(kx+1)-x    )*(gly(ky+1)  -y)
      A01 = (glx(kx+1)-x    )*(y    -gly(ky))
      A10 = (x      -glx(kx))*(gly(ky+1)  -y)
      A11 = (x      -glx(kx))*(y    -gly(ky))

      A = (glx(kx+1)-glx(kx)) * (gly(ky+1)-gly(ky))

      w00 = A00/A
      w01 = A01/A
      w10 = A10/A
      w11 = A11/A

c--------------
c interpolation
c--------------

      vux = w00 * gux(kx  ,ky)
     +    + w01 * gux(kx  ,ky+1)
     +    + w10 * gux(kx+1,ky)
     +    + w11 * gux(kx+1,ky+1)

      vuy = w00 * guy(kx  ,ky)
     +    + w01 * guy(kx  ,ky+1)
     +    + w10 * guy(kx+1,ky)
     +    + w11 * guy(kx+1,ky+1)

c-----
c Done
c-----

      Return
      End
