clear all
close all

%=====
 global ab
 global Nxi Neta
 global Dxi Deta
 global xi eta
 global capls
 global x y z J
 global dydxi dydeta dzdxi dzdeta
 global Niter tol
 global elv
 global cang
 global cangle
 global a delta
 global forcex forcey forcez torqux torquy torquz
 global drhosign
 global Ireset
%=====

Igraph_grid1 = 1;
Igraph_grid2 = 1;
Igraph_metric = 0;

%=====

a = 1.0;

drhosign =-1.0;
drhosign = 1.0;

%---
problem = 2;
problem = 1;
%---

m = 4; % square
m = 6; % hexagonal

xi0=0.25;
xi0=1.5;
xi0=1.25;
xi0=3.0;
xi0=2.0;
xi0=1.0;
xi0=0.5;

complete = 1; % all of the grid
complete = 0; % part of part of the grid

Niter = 20000;
tol = 0.000001;

cang = 0.0;  % initialize

%~~~~~~~
if(problem == 1)
%~~~~~~~

 %---
 % case A: alpha = 0.25pi
 %
 capl = 4.5036*a;
 elv = 1.3210*a;
 %---

 %---
 % case B: alpha = 0.375pi
 %
 capl = 4.5036*a;
 elv = 0.6792*a;
 %---

 Ireset = 0;  % reset the position of the contact line?
 Ireset = 1;  % reset the position of the contact line?

 if(Ireset==0)
  elv = 0.0;
 end

 capl = 1.0;
 capl = 2.0;
 capl = 1000.0;

 delta =-2.0;
 delta = 2.0;
 delta =-4.0;
 delta =-5.0;
 delta = 2.0;
 delta =-2.0;
 delta =-1.0;
 delta = 0.2;
 delta = 1.2;
 delta = 0.1;
 delta = 0.75;
 delta = 1.0;
 delta = 1.1;
 delta = 0.3;
 delta = 0.25;
 delta = 0.20;
 delta = 0.5;
 delta = 0.0;

end
%~~~~~~~

%~~~~~~~
if(problem == 2)  % specify the contact angle
%---
% case A: b= 2.356, alpha = 0.25pi
%
 capl = 4.5036*a;
 elv = 0.3333*a;  % initial guess

 capl = 1000.0*a;

 cang = 0.500*pi;
 cang = 0.125*pi;
 cang = 0.250*pi;

 Ireset = 1;  % reset the position of the contact line?

 elv = 0.00;  % initial guess

delta =-1.0;
delta =-0.5;
delta = 1.0;
delta = 2.0;
delta =-2.0;
delta = 0.0;
delta = 2.0;
delta = 5.0;
delta =-5.0;
delta =-4.0;
delta =-3.0;
delta =-2.0;
delta = 3.0;

end
%~~~~~~~

Np = 4;
Np = 2;
Np = 1;

%---
% prepare
%---

capls = capl^2;

Nxi = Np*8;
Neta = Np*8;

%---
% generate the grid
%---

[wr,wi,b] = fgrid (a,m,xi0,complete);

deltamax = 4*pi/(3*sqrt(3)*b*b/a^2-2*pi)

%---
% base vectors
%---

if(m==4)

 ab(1,1) = 2.0*b;    % first
 ab(1,2) = 0.0;
 ab(2,1) = 0.0;      % second
 ab(2,2) = 2.0*b;

end

if(m==6)

 ab(1,1) = sqrt(3)*b;    % first
 ab(1,2) = 0.0;
 ab(2,1) = b*sqrt(3)/2;  % second
 ab(2,2) = 3/2*b;

end

%================
if(Igraph_grid1==1)
%================

%---
% plot the grid in parametric space
%---

figure(1)
hold on
for i=1:Nxi+1
 plot(wr(i,:),wi(i,:),'.-k')
end
for j=1:Neta+1
 plot(wr(:,j),wi(:,j),'.-k')
end
axis square
win = 1.2*wr(Nxi+1,1);
axis([-win win -win win])
xlabel('real(w)','fontsize',15);
ylabel('imag(w)','fontsize',15);
set(gca,'fontsize',15)

box on

%===
end
%===

%================
if(Igraph_grid2==1)
%================

%---
% plot the solution domain
%---

figure(2)
hold on

%for ip=-1:1
%for jp=-1:1
 for ip=0:0
 for jp=0:0
 for i=1:Nxi+1
  plot(y(i,1:Neta+1)+ip*ab(1,1)+jp*ab(2,1) ...
      ,z(i,1:Neta+1)+ip*ab(1,2)+jp*ab(2,2) ...
      ,'-k.')
 end
 for j=1:Neta+1
  plot(y(1:Nxi+1,j),z(1:Nxi+1,j),'.-')
  plot(y(1:Nxi+1,j)+ip*ab(1,1)+jp*ab(2,1) ...
      ,z(1:Nxi+1,j)+ip*ab(1,2)+jp*ab(2,2) ...
      ,'-k.')
 end
end
end
%plot(y(1,1),z(1,1),'ro')
axis square
 win = b;
 if(complete==1) win = 1.2*b; end
axis([-win win -win win])
xlabel('y/a','fontsize',15);
ylabel('z/a','fontsize',15);
set(gca,'fontsize',15)
box on

%===
end
%===

%==================
if(Igraph_metric==1)
%==================

%---
% plot the metric
%---

figure(3)
hold on

for i=1:Nxi+1
 plot3(y(i,:),z(i,:),J(i,:),'.-k')
end
for j=1:Neta+1
 plot3(y(1:Nxi+1,j),z(1:Nxi+1,j),J(1:Nxi+1,j),'.-k')
end
axis square
 win = b;
 if(complete==1) win = 1.2*b; end
axis([-win win -win win])
xlabel('real(w)','fontsize',15);
ylabel('imag(w)','fontsize',15);
set(gca,'fontsize',15)

%=====
end
%=====

%===
% polar angle around the contact angle
%===

 ycnt = 0.0;
 zcnt = 0.0;

 for j=1:Neta+1
  rr = sqrt((y(1,j)-ycnt)^2+(z(1,j)-zcnt)^2);
  theta(j) = acos((y(1,j)-ycnt)/rr);
  if(z(1,j)<-0.0001)
  theta(j) = 2*pi-theta(j);
  end
 end

%==============
% initialize the interfacial elevation
%==============

for i=1:Nxi+2
 for j=1:Neta+2
  x(i,j) = 0.0;
 end
end

amp = 0.1;
amp = 0.0;

for j=1:Neta+1
 xcontact(j) = elv*(1+amp*cos(6.0*eta(j)));
end

%==============
% compute the interfacial shape
%==============

%==============
 if(problem==1)
%==============

 obj = men_3d_2p_fun(xcontact);
%obj = men_3d_2p_fun1(xcontact);

 %---
 % plot the contact angle
 %---

 figure(40)
 hold on
 plot(12*theta(1:Neta+1)/(2*pi),cangle(1:Neta+1)/pi,'-ok')
 axis([0 1 0.0 0.50])
 xlabel('6\theta/\pi','fontsize',15);
 ylabel('\alpha/\pi','fontsize',15);
 set(gca,'fontsize',15)
 box on

%==============
 elseif(problem==2)
%==============

 Jeps = 0.001;

 obj = men_3d_2p_fun(xcontact);

 xcontactold = xcontact;

 %~~
 for iterate = 1:10
 %~~

%if(iterate==1)

  for j=1:Neta+1
   xcontact(j) = xcontact(j) + Jeps;
   objtmp = men_3d_2p_fun(xcontact);
   for i=1:Neta+1
    Jac(i,j) = (objtmp(i)-obj(i))/Jeps;
   end
   xcontact(j) = xcontact(j) - Jeps;
  end

%end

 xcontact = xcontact - obj/Jac';

 obj = men_3d_2p_fun(xcontact);

  err = 0;
  for i=1:Neta+1
   diff = abs(xcontact(i)-xcontactold(i));
   if(diff>err) err=diff; end
  end

  err
  iterate

  if(err<0.0001) break; end

  xcontactold = xcontact;

 %~~
  end % of iterate
 %~~

%===
 end % of problem
%===

%[forcex forcey forcez torqux torquy torquz]
12*forcex

%====
% plot the solution in physical space
%===

 figure(20)
 colormap('gray')
 colormap('bone')
 hold on;

%---
 for sides=1:m
%---

 angle = 2.0*(sides-1.0)*pi/m;
 ROT(1,1) = cos(angle); ROT(1,2) = sin(angle);
 ROT(2,1) = -ROT(1,2); ROT(2,2) = ROT(1,1);

 for i=1:Nxi+1
  for j=1:Neta+1
  tmp = ROT*[y(i,j), z(i,j)]';
  yrot(i,j) = tmp(1);
  zrot(i,j) = tmp(2);
  end
 end

%---
 Nper = 0;

 for ip=-Nper:Nper
 for jp=-Nper:Nper
%---
 for r = -1:2:1

 yr =   yrot+ip*ab(1,1)+jp*ab(2,1);
 zr = r*zrot+ip*ab(1,2)+jp*ab(2,2);

 for i=1:Nxi
  for j=1:Neta
   patch([yr(i,j), yr(i,j+1), yr(i+1,j+1), yr(i+1,j)] ...
        ,[zr(i,j), zr(i,j+1), zr(i+1,j+1), zr(i+1,j)] ...
        ,[x(i,j), x(i,j+1), x(i+1,j+1),  x(i+1,j)] ...
        ,'w');
%       ,[x(i,j), x(i,j+1), x(i+1,j+1),  x(i+1,j)]);
  end
 end
 end
%---
 end
 end
%---

 end

 xlabel('y/a','fontsize',15);
 ylabel('z/a','fontsize',15);
 zlabel('x/a','fontsize',15);
 set(gca,'fontsize',15)

 axis equal
 win = b;
 axis([-win win -win win -win win])
 view(162, 12)
 axis off

%====
% plot the solution in parameter space
%===

 figure(80)
 colormap('bone')
 surf(eta(1:Neta+1)/pi,xi(1:Nxi+1)/xi0,x(1:Nxi+1,1:Neta+1))
 xlabel('\eta/\pi','fontsize',15);
 ylabel('\xi/\xi_0','fontsize',15);
 zlabel('\zeta/a','fontsize',15);
 set(gca,'fontsize',15)
 axis([0 1/6 0 1 -0.2*a 1.2*a])
 view(150, 24)
 box on
