       subroutine men_ax_ode
     +
     +   (npts
     +   ,capls
     +   ,dthet
     +   ,h
     +   ,x,s
     +   )

c=======================================
c FDLIB
c
c Copyright by C. Pozrikidis, 1999
c All rights reserved.
c
c This program is to be used only under the
c stipulations of the lisencing agreement
c=======================================

c--------------------------------------------
c Integrate ODEs by the modified Euler method
c uniform step size for theta
c--------------------------------------------

      Implicit double precision (a-h,o-z)

      Dimension x(800),s(800)

c--------
c prepare
c--------

      dtheth = 0.5D0*dthet

c-----------
c centerline
c-----------

       thet = 0.0D0
       s(1) = 0.0D0
       x(1) = 0.0D0

c------------------------------------------
c integrate using the modified Euler method
c------------------------------------------

c---
       Do i=1,npts
c---

        if(i.eq.1) then
         xp = 0.0D0
         sp = 2.0D0*capls/h
        else
         cs = Dcos(thet)
         sn = Dsin(thet)
         Q  = (x(i)+h)/capls-sn/s(i)
         xp = sn/Q
         sp = cs/Q
        end If

        xsv  = x(i)  ! save
        ssv  = s(i)  ! save
        xpsv = xp
        spsv = sp

        i1 = i+1

        thet  = thet+dthet
        x(i1) = x(i)+xp*dthet
        s(i1) = s(i)+sp*dthet

        cs = cos(thet)
        sn = sin(thet)
        Q  = (x(i1)+h)/capls-sn/s(i1)
        xp = sn/Q
        sp = cs/Q

        x(i1) = xsv + (xpsv+xp)*dtheth
        s(i1) = ssv + (spsv+sp)*dtheth

c---
       End Do
c---

c-----
c done
c-----

       return
       end
