      subroutine chan_2d_imp
     +
     +  (h
     +  ,visc
     +  ,den
     +  ,V
     +  ,Max
     +  ,time
     +  ,y
     +  ,u
     +  )

c==========================================
c FDLIB
c
c Copyright by C. Pozrikidis, 1999
c All rights reserved
c
c This program is to be used only under the
c stipulations of the licensing agreement
c==========================================

c==========================================
c Flow in a channel confined between two parallel walls
c due to the impulsive translation of the lower wall
c parallel to itself at constant velocity.
c
c The walls are located at y = 0, h
c==========================================

      Implicit Double Precision (a-h,o-z)

c----------
c constants
c----------

      pi = 3.14159 265358D0

c--------
c prepare
c--------

      hs  = h*h
      rnu = visc/den   ! kinematic viscosity

c---------------------
c compute the velocity
c---------------------

      u = 0.0D0

      Do j=1,Max
       u = u + Dsin(j*pi*y/h)*exp(-j*j*pi*pi*rnu*time/hs)/j
      End Do

      u = V*(1.0-y/h-2.0*u/pi)

c-----
c done
c-----

      Return
      End
