close all
hold on

%=====================================================
% Flow in a channel confined between two parallel walls
% due to the impulsive motion of the lower wall
% parallel to itself with constant velocity. V
%
% The walls are located at y = 0, h
%=====================================================

nprof = 32;    % number of points for a profile
h = 1.0;        % channel width 
visc = 1.0;    % viscosity
den = 1.0;     % density
V = 1.0;       % wall velocity
Max = 32;      % truncation limit for summation

step=h/nprof;

%---
 for iloop=1:16
%---

     if(iloop==1) time=0.001;
 elseif(iloop==2) time=0.005;
 elseif(iloop==3) time=0.010;
 else
  time=time+0.01;
 end

 y = 0;

 for i=1:nprof+1

  u = chan_2d_imp  ...
 ...
     (h ...
     ,visc ...
     ,den ...
     ,V ...
     ,Max ...
     ,time ...
     ,y ...
     );

  xplot(i)=u/V;
  yplot(i)=y/h;

  y=y+step;

 end

 plot(xplot,yplot,'k')

%---
 end
%---

 plot([0 1],[h,0],'r--')

 xmin=-0.05; xmax=1.0;
 ymin= -0.2; ymax=1.2;
 axis([xmin xmax ymin ymax])
 plot([0 0],[0 h],'k');
 plot([xmin xmax],[0 0],'r','linewidth',4);
 plot([xmin xmax],[h h],'r','linewidth',4);
 xlabel('u_x/V','fontsize',15)
 ylabel('y/h','fontsize',15)
 set(gca,'fontsize',15)
 box
