clear all
close all

%=============================================
% Multi-layer channel flow
%=============================================

%---
% input
%---

a = 0.6145;
V1 = 1.0;
V2 =-0.1;
chi = 3.0;
gac = 1.0;
beta = 0.125;

NLR = 6;
thick = [0.271 0.128  0.29  0.2 0.2];
visc  = [1.0   2.5   10.00  3.0 2.0  4.0];
den   = [9.0   0.5    1.60  1.0 1.3  1.4];

%---
% last layer thickness
%---

sum = 0.0;

for i=1:NLR-1
  sum = sum+thick(i);
end

thick(NLR) = 2*a-sum;

%---
% prepare
%---

beta = beta*pi;

%---
% launch
%---

y = 0;

[Q,u,xi1,xi2,yI,uI] = chan_2d_ml ...
     ...
       (NLR ...
       ,a ...
       ,thick ...
       ,visc ...
       ,den ...
       ,gac ...
       ,V1 ...
       ,V2 ...
       ,chi ...
       ,beta ...
       ,y ...
       )

