clear all
close all

%--------------------------------------------------
% Flow in a channel due to an oscillating wall
% The walls are located at y = 0, h
% The lower wall is oscillating with amplitude: Vamp
% V_wall = Vamp * cos(omega*time)
%--------------------------------------------------

nprof = 32;    % number of points for a profile
h = 1.0;        % channel width 
visc = 1.0;    % viscosity
den = 1.0;     % density
Vamp = 1.0;      % wall velocity amplitude

omega = 36.0;   % angular frequency
omega = 4.0;   % angular frequency
omega = 100.0;   % angular frequency
omega = 400.0;   % angular frequency

step=h/nprof;

figure(1)
hold on

%---
 for iloop=1:8
%---

     if(iloop==1) ot=0.00*pi;
 elseif(iloop==2) ot=0.25*pi;
 elseif(iloop==3) ot=0.50*pi;
 elseif(iloop==4) ot=0.75*pi;
 elseif(iloop==5) ot=1.00*pi;
 elseif(iloop==6) ot=1.25*pi;
 elseif(iloop==7) ot=1.50*pi;
 elseif(iloop==8) ot=1.75*pi;
 end

 y=0;

 for i=1:nprof+1

  u = chan_2d_osc  ...
 ...
     (h ...
     ,visc ...
     ,den ...
     ,Vamp ...
     ,omega ...
     ,ot ...
     ,y ...
     );

  xplot(i)=u;
  yplot(i)=y;

  y=y+step;

 end

 if(iloop==1)
  plot(xplot,yplot,'k--')
 elseif(iloop==3)
  plot(xplot,yplot,'k:')
 else
  plot(xplot,yplot,'k')
 end

%---
 end
%---

 xmin=-1; xmax=1.0;
 ymin= -0.2; ymax=1.2;

 plot([0 0],[0 h],'c');
 plot([xmin xmax],[0 0],'r','linewidth',4);
 plot([xmin xmax],[h h],'r','linewidth',4);

 axis([xmin xmax ymin ymax])
 xlabel('u_x/V','fontsize',15)
 ylabel('y/h','fontsize',15)
 set(gca,'fontsize',15)
 box
