      subroutine chan_2d_trans
     +
     +  (h
     +  ,visc
     +  ,den
     +  ,pg
     +  ,maxsm
     +  ,time
     +  ,y
     +  ,u
     +  )

c=========================================
c FDLIB, FDLIBM
c
c Copyright by C. Pozrikidis, 1999
c All rights reserved
c
c This program is to be used only under the
c stipulations of the licensing agreement
c=========================================

c=========================================
c Flow in a channel due to sudden tilting or
c application of a constant pressure gradint
c
c The channel is confined between two parallel walls
c located at y = 0 and h
c=========================================

      Implicit Double Precision (a-h,o-z)

c----------
c constants
c----------

      pi  = 3.14159 265358 D0

c--------
c prepare
c--------

      hs  = h*h
      rnu = visc/den          ! kinematic viscosity
      yr  = pi*y/h             ! reduced y
      tr  = pi*pi*rnu*time/hs    ! reduced time

c---------------------
c compute the velocity
c---------------------

      u = 0.0D0

      Do j=1,maxsm,2
        u = u + sin(j*yr)*exp(-j*j*tr)/(j*j*j)
      End Do

      u = 4.0*pg*hs*u/(visc*pi*pi*pi)
      u = 0.5*pg*(h-y)*y/visc - u

c-----
c Done
c-----

      Return
      End
