function u = chan_2d_trans ...
 ...
       (h ...
       ,visc ...
       ,den ...
       ,pg ...
       ,maxsm ...
       ,time ...
       ,y ...
       )

%==========================================
% Flow in a channel due to sudden tilting or
% application of a constant pressure gradint
%
% The channel is confined between two parallel
% walls located at y = 0 and h
%==========================================

%--------
% prepare
%--------

  hs  = h*h;
  rnu = visc/den;         % kinematic viscosity
  yr = pi*y/h;            % reduced y
  tr = pi*pi*rnu*time/hs;   % reduced time

%---------------------
% compute the velocity
%---------------------

  u = 0.0;

  for j=1:2:maxsm
    u = u + sin(j*yr)*exp(-j*j*tr)/(j*j*j);
  end

  u = 4.0*pg*hs*u/(visc*pi*pi*pi);
  u = 0.5*pg*(h-y)*y/visc - u;

%---
% done
%---

return
