      subroutine chan_2d_wom
     +
     +  (h
     +  ,visc
     +  ,den
     +  ,pgamp
     +  ,Omega
     +  ,ot
     +  ,y
     +  ,u
     +  )

c========================================
c FDLIB
c
c Copyright by C. Pozrikidis, 1999
c All rights reserved
c
c This program is to be used only under the
c stipulations of the licensing agreement
c========================================

c========================================
c Flow in a  channel due to an oscillatory
c pressure gradient:
c
c pg = pgamp * sin(Omega*time)
c
c The channel walls are located at y = 0, h
c========================================

      Implicit Double Precision (a-h,o-z)

c--------
c prepare
c--------

      rnu   = visc/den           ! kinematic viscosity

      delta = Dsqrt(2.0*rnu/Omega)
      hr    = h/delta
      hrh   = 0.5D0*hr
      denr  = cosh(hrh)*Dcos(hrh)
      deni  =-sinh(hrh)*Dsin(hrh)
      dens  = denr*denr+deni*deni
      aar   =  denr/dens
      aai   = -deni/dens
      cs = Dcos(ot)
      sn = Dsin(ot)

c---
c compute the velocity
c---

      yr  = y/delta              ! reduced position
      tmp = yr-0.5*hr
      bbr = cosh(tmp)*cos(tmp)
      bbi =-sinh(tmp)*sin(tmp)
      ccr = aar*bbr-aai*bbi
      cci = aar*bbi+aai*bbr
      ccr = 1.0D0-ccr
      cci =      -cci
      tmp = cs*ccr+sn*cci
      u   = -pgamp*tmp/(den*Omega)

c-----
c done
c-----

      Return
      End
