      subroutine plate_imp
     +
     +   (visc
     +   ,den
     +   ,Up 
     +   ,time
     +   ,y
     +   ,u
     +   )

c-----------------------------------------
c FDLIB
c
c Copyright by C. Pozrikidis, 1999
c All rights reserved.
c
c This program is to be used only under the
c stipulations of the licensing agreement.
c----------------------------------------

c--------------------------------------------
c Flow due to the impulsive motion of a plate
c in a semi-infinite fluid
c
c Equation (5.2.11) of Pozrikidis (1997,p.195)
c--------------------------------------------

      Implicit Double Precision (a-h,o-z)

c--------
c prepare
c--------

      rnu  = visc/den    ! kinematic viscosity
      srnt = Dsqrt(rnu*time)

c---
c compute the velocity
c---

      eta = y/srnt
      tmp = 0.5D0*eta
      u   = Up*erfc(tmp)

c-----
c Done
c-----
                                
      Return
      End

c=============================

      function erfc(X)

c-----------------------------
c complementary error function
c-----------------------------

      Implicit Double Precision (a-h,o-z)

      T    = 1.0/(1.0 + 0.3275911*ABS(X))

      ERFC = T*exp(-X**2)*(0.254829592 +T*(-0.284496736 +
     +       T*( 1.421413741 +T*(-1.453152027 +T*1.061405429))))

      If(X.lt.0.0) erfc = 2.0 - erfc

      Return
      End
