      subroutine plate_osc
     +
     +   (visc
     +   ,den
     +   ,Vamp
     +   ,Omega
     +   ,ot
     +   ,y
     +   ,u
     +   )

c========================================
c FDLIB
c
c Copyright by C. Pozrikidis, 1999
c All rights reserved
c
c This program is to be used only under the
c stipulations of the licensing agreement
c========================================

c====================================
c Rayleigh's first problem:
c
c Unidirectional flow in a semi-infinite fluid
c due to an oscillating plate 
c====================================

      Implicit Double Precision (a-h,o-z)

c----------
c constants
c----------

      pi = 3.14159 265358 D0

c--------
c prepare
c--------

      rnu   = visc/den           ! kinematic viscosity
      delta = Dsqrt(2.0D0*rnu/Omega)

c---------------------
c compute the velocity
c---------------------

      yr = y/delta
      u  = Vamp * Dexp(-yr) * Dcos(ot-yr)

c-----
c Done
c-----

      Return
      End
