function u = plate_osc ...
 ...
   (visc ...
   ,den ...
   ,Vamp ...
   ,Omega ...
   ,ot ...
   ,y ...
   )

%------------------------------
% Rayleigh's first problem:
%
% Unidirectional flow in a semi-infinite fluid
% due to an oscillating plate 
%------------------------------

%--------
% prepare
%--------

 rnu   = visc/den;             % kinematic viscosity
 delta = sqrt(2.0*rnu/Omega);  % boundary-layer thickness

%---------------------
% compute the velocity
%---------------------

 yr = y/delta;
 u  = Vamp*exp(-yr)*cos(ot-yr);

%---
% done
%---

return
