      program plate_osc_dr


c========================================
c FDLIB
c
c Copyright by C. Pozrikidis, 1999
c All rights reserved.
c
c This program is to be used only under the
c stipulations of the licensing agreement
c========================================

c============================
c Rayleigh's first problem:
c
c Unidirectional flow in a semi-infinite fluid 
c due to an oscillating plate 
c============================

      Implicit Double Precision (a-h,o-z)

c----------
c constants
c----------

      pi = 3.14159 265358 D0

      null = 0
      None = 1
      Ntwo = 2

c------
c Input
c------

      open  (1,file="plate_osc.dat",status="unknown")
       read (1,*) nprof
       read (1,*) ymax
       read (1,*) visc
       read (1,*) den
       read (1,*) Omega
       read (1,*) Vamp
      close (1)

c---------------
c prepare to run
c---------------

      open (2,file="plate_osc.out",status="unknown")

      nprof1 = nprof+1
      step   = ymax/(nprof1-1.0)

c---
c plot the plate
c---

      write (2,900) Ntwo
      write (2,900) None,-2.0*Vamp,zero
      write (2,900) Ntwo, 2.0*Uamp,zero

c---
c plot a vertical line
c---

      write (2,900) Ntwo
      write (2,900) None,zero,zero
      write (2,900) Ntwo,zero,ymax

c---
c profiles
c---

 93   Continue

      write (6,*)
      write (6,*) " Please enter Omega*t in multiples of pi"
      write (6,*) " Omega is the angular frequency"
      write (6,*)
      write (6,*) " Enter 99 to quit"
      write (6,*) " ----------------"
      read (5,*) ot

      if(ot.eq.99) Go to 99

      ot = ot*pi

      write (6,*)
      write (6,*) "u, y"
      write (6,*)

      write (2,900) nprof1

      y = 0.0

      Do i=1,nprof1

        call plate_osc
     +
     +     (visc
     +     ,den
     +     ,Vamp
     +     ,Omega
     +     ,ot
     +     ,y
     +     ,u
     +     )

        write (2,900) i,u,y
        write (6,900) i,u,y

        y = y+step

      End Do

      Go to 93

c-----
c Done
c-----

  99  Continue

      write (2,900) null

      close (2)

 900  Format (1x,i3,4(1x,f10.5))

      Stop
      End
