%---
clear all
close all
%---

%==================================
% Rayleigh's first problem:
%
% Unidirectional flow in a semi-infinite fluid
% due to an oscillating plate 
%==================================

nprof = 32;    % number of points for a profile
ymax  = 8;     % channel width 
visc  = 1.0;   % viscosity
den   = 1.0;   % density
Vamp   = 1.0;  % wall velocity amplitude

Omega = 1.0;   % angular frequency

delta = sqrt(2.0*visc/(Omega*den));

step = ymax/nprof;

figure(1)
hold on

%---
 for iloop=1:8
%---

     if(iloop==1) ot=0.00*pi;
 elseif(iloop==2) ot=0.25*pi;
 elseif(iloop==3) ot=0.50*pi;
 elseif(iloop==4) ot=0.75*pi;
 elseif(iloop==5) ot=1.00*pi;
 elseif(iloop==6) ot=1.25*pi;
 elseif(iloop==7) ot=1.50*pi;
 elseif(iloop==8) ot=1.75*pi;
 end

 y = 0;

 for i=1:nprof+1

  u = plate_osc ...
  ...
    (visc ...
    ,den ...
    ,Vamp ...
    ,Omega ...
    ,ot ...
    ,y ...
    );

  xplot(i) = u/Vamp;
  yplot(i) = y/delta;

  y = y+step;

 end

 if(iloop==1)
  plot(xplot,yplot,'k--')
 elseif(iloop==2)
  plot(xplot,yplot,'k-.')
 elseif(iloop==3)
  plot(xplot,yplot,'k:')
 else
  plot(xplot,yplot,'k')
 end

%---
 end
%---

 xmin=-1; xmax=1.0;
 ymin= -0.2; ymax=5;
 axis([xmin xmax ymin ymax])
 plot([0 0],[0 ymax],'c');
 plot([xmin xmax],[0 0],'r','linewidth',4);
 xlabel('u_x/V','fontsize',15)
 ylabel('y/\delta','fontsize',15)
 set(gca,'fontsize',15)
 box
