      subroutine ellipse (x,y,a,b,Vx,Vy,circ,f)

c---
c stream function for streaming potential flow
c past an ellipse
c---

      Implicit double precision (a-h,o-z)

c---
c constants
c---

      pi   = 3.14159 265358
      pi2  = 2.0*pi
      pi4  = 4.0*pi

c---
c find coordinates in the zeta plane
c equation (7.10.4) of Pozrikidis (1997)
c---

      prag = x*x-y*y-a*a+b*b
      fant = 2.0*x*y
      rrrr = sqrt(prag**2+fant**2)
      thet = acos(prag/rrrr)

      if(x.lt.0.and.y.gt.0) thet = pi2-thet
      if(x.lt.0.and.y.lt.0) thet = pi2+thet
      if(x.gt.0.and.y.lt.0) thet = pi4-thet

      tmp  = sqrt(rrrr)
      phi  = 0.5*thet
      xx   = 0.5*(x+tmp*cos(phi))
      yy   = 0.5*(y+tmp*sin(phi))
    
      c  = 0.50*(a+b)    ! radius of the circle in the zeta plane
      cs = c*c

c---
c flow past a circle in the zeta plane
c---

      r = sqrt(xx*xx+yy*yy)
      q = acos(xx/r)
      if(yy.le.0) q = -q

      f = -2.0*circ*log(r)+(r-cs/r)*(Vx*sin(q)-Vy*cos(q))

c---
c done
c---

      return
      end
