      subroutine moffatt (x,y,alpha,rlr,rli,Ieddies,Isymm,f)

c--------------------------
c Stokes flow near a corner
c--------------------------

      Implicit Double Precision (a-h,o-z)

      a = alpha
      r = sqrt(x*x+y*y)
      q = acos(x/r)

c--------------------------
      if(Ieddies.eq.0) then     ! eddies do not form
c--------------------------

        rq  = rlr*q
        ra  = rlr*a
        rq2 = (rlr-2.0)*q
        ra2 = (rlr-2.0)*a

        if(Isymm.eq.0) then
         f =  cos(rq)*cos(ra2)-cos(ra)*cos(rq2)
        else
         f = -sin(rq)*sin(ra2)+sin(ra)*sin(rq2)
        end if

c---------
      else                     ! eddies form
c---------

        rqr     = rlr*q
        rqi     = rli*q
        a1      = exp( rqi)
        a2      = exp(-rqi)
        coshrqi = 0.50*(a1+a2)
        sinhrqi = 0.50*(a1-a2)
        rar     = rlr*a
        rai     = rli*a
        a1      = exp( rai)
        a2      = exp(-rai)
        coshrai = 0.50*(a1+a2)
        sinhrai = 0.50*(a1-a2)
        rqr2    = (rlr-2.0)*q
        rar2    = (rlr-2.0)*a

        if(Isymm.eq.0) then
         cosrqr  =   cos(rqr )*coshrqi
         cosrqi  = - sin(rqr )*sinhrqi
         cosrq2r =   cos(rqr2)*coshrqi
         cosrq2i = - sin(rqr2)*sinhrqi
         cosrar  =   cos(rar )*coshrai
         cosrai  = - sin(rar )*sinhrai
         cosra2r =   cos(rar2)*coshrai
         cosra2i = - sin(rar2)*sinhrai
         Pr = cosrqr*cosra2r - cosrqi*cosra2i
     +       -cosrar*cosrq2r + cosrai*cosrq2i
         Pi = cosrqr*cosra2i + cosrqi*cosra2r
     +       -cosrar*cosrq2i - cosrai*cosrq2r
        else
         sinrqr  =  sin(rqr )*coshrqi
         sinrqi  =  cos(rqr )*sinhrqi
         sinrq2r =  sin(rqr2)*coshrqi
         sinrq2i =  cos(rqr2)*sinhrqi
         sinrar  =  sin(rar )*coshrai
         sinrai  =  cos(rar )*sinhrai
         sinra2r =  sin(rar2)*coshrai
         sinra2i =  cos(rar2)*sinhrai
         Pr = sinrqr*sinra2r - sinrqi*sinra2i
     +       -sinrar*sinrq2r + sinrai*sinrq2i
         Pi = sinrqr*sinra2i + sinrqi*sinra2r
     +       -sinrar*sinrq2i - sinrai*sinrq2r
        end if

        tmp = rli*log(r)
        f   = Pr*cos(tmp)-Pi*sin(tmp)

c-----------
      end if
c----------

      f = f* r**rlr

c---
c done
c---

      return
      end
