      subroutine sphrd_ob (x,y,b,c,Iflow,delx,dely,f)

c---
c Potential flow past a prolate spheroid
c Analytical solution 
c---

      Implicit double precision (a-h,o-z)

c---
c find the value of zeta and mu
c---

c---
      if(Iflow.eq.1) then        ! Axial flow
c---
      aq = c*c
      bq = -x*x-y*y+c*c
      cq = -x**2
      discr = bq**2-4.0*aq*cq
      if(discr.lt.0) stop
      discr = sqrt(discr)
      zetas = (-bq+discr)/(2.0*aq)
      zeta  = sqrt(zetas)
      rmu = x/(c*zeta)

      f = bb*rmu*(1.0-zeta*atan(1.0/zeta))/delx
c---
      elseif(Iflow.eq.2) then   ! transverse flow
c---
      aq = c*c
      bq = -x**2-y**2+c**2
      cq = -y*y
      discr = bq**2-4.0*aq*cq
      if(discr.lt.0) stop
      discr = sqrt(discr)
      zetas = (-bq+discr)/(2.0*aq)
      zeta  = sqrt(zetas)

      f = x/(dely)*(zeta/(zetas+1.0)-atan(1.0/zeta))
      if(x.gt.0) f = -f

c---
      End If
c---
      f = -f+x

c---
c done
c---

      return
      end
