      subroutine sphrd_pr (x,y,c,delx,dely,Iflow,f)

c---
c Potential flow past a prolate spheroid
c Evaluation of the velocity potential
c from a singularity representation
c---

      Implicit double precision (a-h,o-z)

      N   = 64
      dx0 = 2.0*c/N
      f   = 0.0

c---
      if(Iflow.eq.1) then   ! Axial flow
c---
        Do i=1,N
          x0 = -c+(i-0.50)*dx0
          dx = x-x0
          r2 = dx*dx+y*y
          r  = sqrt(r2)
          r3 = r2*r
          d  = c*c-x0*x0
          f = f + dx*d/r3
        End Do

        f = - 0.5*f*dx0/delx
c---
      else                    ! Transverse flow
c---
        Do i=1,N
          x0 = -c+(i-0.50)*dx0
          r2 = x0*x0+x*x+y*y
          r  = sqrt(r2)
          r3 = r2*r
          d  = c*c-x0*x0
          f = f + x*d/r3
        End Do

        f = - 0.5*f*dx0/dely
c---
      End If
c---

      f = -f+x

c---
c Done
c---

      Return
      End
