      program tube_crc_sec_dr

c=========================================
c Copyright by C. Pozrikidis, 1999
c All rights reserved
c
c This program is to be used only under the
c stipulations of the licensing agreement
c=========================================

c=========================================
c Steady flow through a circular tube
c due to the translation of a sector of the tube
c
c The moving sector is confined between:
c -alpha < theta < theta
c
c SYMBOLS:
c --------
c
c alpha:  semi-angle of the moving sector
c=========================================

      Implicit Double Precision (a-h,o-z)

c----------
c constants
c----------

      pi = 3.14159 265358D0

c------------
c preferences
c------------

      open (1,file="tube_crc_sec.dat",status="unknown")

       read (1,*) nprof
       read (1,*) a       ! tube radius
       read (1,*) alpha
       read (1,*) V        ! wall sector velocity

      close (1)

c--------------------------
c prepare to draw a profile
c--------------------------

      open (2,file="tube_crc_sec.out",status="unknown")

      nprof1 = nprof+1

      alpha = alpha*pi

c------------
c preferences
c------------

  98  Continue

      write (6,*)
      write (6,*) "Please enter the polar angle of the profile"
      write (6,*) "in multiples of pi"
      write (6,*)
      write (6,*) "99 to stop"
      write (6,*) "----------"
      write (6,*)
      read  (5,*) phi

      if(phi.eq.99) Go to 99

      phi = phi*pi

c---
c profile
c---

      write (2,900) nprof1,phi/pi

      write (6,*) 
      write (6,900) nprof1,phi/pi
      write (6,*) 
      write (6,*) "u, sigma"
      write (6,*) 

      step = a/(nprof1-1.0)

      Do i=1,nprof1

       sigma = (i-1.0)*step

       call tube_crc_sec
     +
     +    (a
     +    ,alpha
     +    ,sigma
     +    ,phi
     +    ,V
     +    ,u
     +    )
  
       write (2,900) i,u,sigma
       write (6,900) i,u,sigma

      End Do

      Go to 98

c-----
c Done
c-----

  99  Continue

      write (2,900) null
      close (2)

 900  Format (1x,i3,4(1x,f10.5))

      Stop
      End
