      subroutine chan2l_imp_of
     +
     +    (method
     +    ,Dt
     +    ,x,yold
     +    ,y
     +    ,obj
     +    )

c===========================================
c FDLIB
c
c Copyright by C. Pozrikidis, 1999
c All rights reserved.
c
c This program is to be used only under the
c stipulations of the licensing agreement
c===========================================

c----------------------------------------
c Compute the objective function:
c
c  obj = dh1/dt+dQ1/dx
c 
c SYMBOLS
c -------
c
c srtn:  surface tension
c----------------------------------------

      Implicit Double Precision (a-h,o-z)

      Dimension  x(-10:500), y(-10:500),yold(-10:500)
      Dimension h1(-10:500),h2(-10:500),hr(-10:500)
      Dimension obj(-10:500)

      Dimension srtn(-10:500),DsrtnDx(-10:500)

      Dimension DyDx1(-10:500),DyDx2(-10:500),DyDx3(-10:500)
      Dimension uI(-10:500)
      Dimension dp1dx(-10:500)
      Dimension store(-10:500),DyDt(-10:500)

c--------------
c common blocks
c--------------

      common/var1/beta,cth0,sth0,a,as,RL
      common/var2/vs1,vs2,vsr,rho1,rho2,Drho,dnr
      common/var3/V1,V2,pdrop,gx,gy
      common/var4/Dx,Dx2,Dxs,Dx23
      common/var5/NSG,NSG1,NSG2,NSG3,NSG4
      common/var6/srtn,uI

c------------------------------
c compute layer thicknesses
c         spatial derivatives
c         thickness ratio
c------------------------------

      Do i=-3,NSG4
        ib = i-2
        ia = i-1
        i1 = i+1
        i2 = i+2
        DyDx1(i) = (y(i1)-y(ia))/Dx2
        DyDx2(i) = (y(i1)-2.0D0*y(i)+y(ia))/Dxs
        DyDx3(i) = (y(i2)-2.0D0*y(i1)+2.0D0*y(ia)-y(ib))/Dx23
        h1(i) = a+y(i)
        h2(i) = a-y(i)
        hr(i) = h2(i)/h1(i)
      End Do


c------------------
c compute d srtn/dx
c------------------

      Do i=1,NSG1
       DsrtnDx(i) = (srtn(i+1)-srtn(i-1))/Dx2
      End Do

c---------------
c compute dp1/dx
c---------------

      Do i=1,NSG

c--- OLD AND OUTDATED
c
c      tmp = 1.0D0/(vsr+hr(i))
c      t1 = vsr*h1(i)**3+h2(i)**3+12.0*vsr*tmp*as*h2(i)
c      t2 = Drho*gac*cth0/vs1*
c    +      (h2(i)+6.0*vsr*tmp*h)*h2(i)**2 * DyDx1(i)
c      t3 =  - srtn/vs1 * (h2(i)+6.0*vsr*tmp*h)
c    +            * h2(i)**2 * DyDx3(i)
c      t4 = gac*rho1*sth0/vs1
c    +     * (vsr*h1(i)**3 + dnr*h2(i)**3
c    +     + 12.0*vsr*tmp*(1.0+dnr*hr(i))/(1.0+hr(i))
c    +       *as*h2(i))
c      t5 = 6.0*vsr*(V1*h1(i)+V2*h2(i))
c      t6 = 12.0*vsr*h*tmp * (hr(i)*V1+vsr*V2)
c      dp1dx(i) = (t2+t3+t4+t5+t6)/t1
c      store(i) = vs1/t1
c---

       tmp = 1.0D0/(vsr+hr(i))
       Den = vsr*h1(i)**3 + h2(i)**3 + 12.0D0*vsr*tmp*as*h2(i)
       t1 = - Drho*gy*(h2(i)+6.0D0*vsr*tmp*a)*h2(i)**2 * DyDx1(i)
       t2 = - srtn(i)*(h2(i)+6.0D0*vsr*tmp*a)*h2(i)**2 * DyDx3(i)
       t3 =  rho1*gx*(vsr*h1(i)**3 + dnr*h2(i)**3
     +        +6.0D0*vsr*tmp*(1.0D0+dnr*hr(i))*a*h1(i)*h2(i) )
       t4 = 6.0D0*vs2*(V1*h1(i)+V2*h2(i))
     +    + 12.0D0*vsr*a*tmp * (vsr*V2+hr(i)*V1)
       t5 = 12.0D0*vsr*tmp*a*h2(i)*DsrtnDx(i)
       t6 = - ( 6.0D0*vsr*tmp*a + h2(i) )* h2(i)**2 * DyDx2(i)
     +        * DsrtnDx(i)

       dp1dx(i) = (t1+t2+t3+t4+t5+t6)/Den

       store(i) = 1.0/Den

      End Do


c--------------------------
c compute the function f(t)
c--------------------------

      sum1 = 0.0D0
      sum2 = 0.0D0

      Do i=1,NSG
       sum1 = sum1 + dp1dx(i)
       sum2 = sum2 + store(i)
      End Do

      sum1 = sum1*dx
      sum2 = sum2*dx

      f = (pdrop-sum1)/sum2

c-----------------------------------
c complete the computation of dp1/dx
c-----------------------------------

      Do i=1,NSG
        dp1dx(i) = dp1dx(i) + f*store(i)
      End Do

c---------------------
c compute u(interface) 
c---------------------

      Do i=1,NSG

c--- OLD AND OUTDATED
c       uI(i) = h*h2(i)/vs1 * (-dp1dx(i)+rho1*gac*
c    +          (1.0D0+delta*hr(i))/(1.0D0+hr(i)) * sth0)
c    +          +0.5D0*h2(i)**2/vs1 *(rho1*(1.0-delta)
c    +          *cth0*gac*Dydx1(i)
c    +           -srtn*DyDx3(i))
c    +           + hr(i)*V1 + vsr*V2
c       uI(i) = uI(i)/(vsr+hr(i))
c---
        ri1 = 1.0D0+hr(i)
        uI(i) = a*h2(i)/vs1       * (
     +          -dp1dx(i)+rho1*gx*(1.0D0+dnr*hr(i))/ri1 )
     +          +0.5D0*h2(i)**2/vs1
     +            *(-Drho*gy*Dydx1(i)-srtn(i)*DyDx3(i)
     +           -DsrtnDx(i)*DyDx2(i))
     +           + hr(i)*V1+vsr*V2
        uI(i) = uI(i) + DsrtnDx(i)*h2(i)/vs1
        uI(i) = uI(i)/(vsr+hr(i))
      End Do

c-----
c wrap
c-----

      dp1dx(0)    = dp1dx(NSG)
      dp1dx(NSG1) = dp1dx(1)

      uI( 0) = uI(NSG)
      uI(NSG1) = uI(1)
      uI(NSG2) = uI(2)
      uI(NSG3) = uI(3)
      uI(NSG4) = uI(4)

c     uI(-1) = uI(NSGa)
c     uI(-2) = uI(NSGb)
c     uI(-3) = uI(NSGc)


c-------------------
c compute dQ1/dx
c
c finite differences
c-------------------

      pr1 = 12.0D0*Dx2*vs1
      pr2 =  2.0D0*Dx2

      pr3 = 12.0D0*Dx*vs1
      pr4 =  2.0D0*Dx

      Do i=1,NSG

       ia = i-1
       i1 = i+1

c------------
       if(method.eq.1) then      ! central differences
c------------

         dq1dx = ( h1(i1)**3 *(-dp1dx(i1)+rho1*gx)
     +           - h1(ia)**3 *(-dp1dx(ia)+rho1*gx))/pr1
     +       + ( (uI(i1)+V1)*h1(i1)-(uI(ia)+V1)*h1(ia))/pr2

c------------
       else                      ! backward differences
c------------

         dqdDx = ( h1(i )**3 *(-dp1dx(i )+rho1*gx)
     +           - h1(ia)**3 *(-dp1dx(ia)+rho1*gx))/pr3
     +       + ( (uI(i )+V1)*h1(i )
     +          -(uI(ia)+V1)*h1(ia))/pr4
c------------
       end if
c------------

       DyDt(i) = - dq1dx

c----- alternative formulation---------
c
c      sum = (h1(i1)**3*dp1dx(i1) - h1(ia)**3*dp1dx(ia))/Dx2
c      sum = sum - 6.0*(V1-uI(i))*DyDx1(i)
c      sum = sum - 6.0*h1(i)*(uI(i1)-uI(ia))/Dx2
c      DyDt(i) = sum/12.0 - uI(i)*DyDx1(i)
c-------------------------------------

       obj(i) = (y(i)-yold(i))/Dt - DyDt(i)
      
c      write (6,*) i,DyDt(i),(y(i)-yold(i))/Dt,obj(i)
c      write (6,*) i,obj(i)

      End Do

c-----
c Done
c-----

 100  Format (1X,I3,9(1X,F15.10))

      return
      end
