      subroutine elv_max_min
     +
     +   (NSG
     +   ,xmax,ymax
     +   ,xmin,ymin
     +   )

c-----------------------------------------
c Copyright by C. Pozrikidis, 1999
c All rights reserved.
c
c This program is to be used only under the
c stipulations of the licensing agreement.
c----------------------------------------

c-------------------------------------------
c Computation of the maximum and minimum
c elevation of the interface
c and position where these occur
c by local parabolic interpolation
c-------------------------------------------

      Implicit Double Precision (a-h,o-z)

      Dimension x(-10:500),y(-10:500)

      common/XXYY/x,y

c------------------
c Maximum elevation
c------------------

      f = -100.0D0
      M = 0

      Do j=1,NSG
       if(y(j).gt.f) then
         F = y(j)
         M = j
       end if
      End Do

      Ma = M-1
      M1 = M
      M2 = M+1

c---
c parabolic interpolation
c---

      xx0 = x(Ma)
      xx1 = x(M1)
      xx2 = x(M2)

      yy0 = y(Ma)
      yy1 = F
      yy2 = y(M2)

      tm2 = (yy2-yy1)/(xx2-xx1)
      tm1 = (yy0-yy1)/(xx0-xx1)
      bbb = (tm2-tm1)/(xx2-xx0)
      ccc =  tm2-bbb*(xx2-xx1)

      xmax = -0.50D0*ccc   /bbb + xx1
      ymax = -0.25D0*ccc**2/bbb + yy1

c------------------
c Minimum elevation
c------------------

      F = 100.0D0
      M = 0

      Do J=1,NSG
       if(y(J).lt.F) then
         F = y(J)
         M = J
       end if
      End Do

      Ma = M-1
      M1 = M
      M2 = M+1

c---
c parabolic interpolation
c---

      xx0 = x(Ma)
      xx1 = x(M1)
      xx2 = x(M2)

      yy0 = y(Ma)
      yy1 = F
      yy2 = y(M2)

      tm2 = (yy2-yy1)/(xx2-xx1)
      tm1 = (yy0-yy1)/(xx0-xx1)
      bbb = (tm2-tm1)/(xx2-xx0)
      ccc = tm2-bbb*(xx2-xx1)

      xmin = -0.50D0*ccc   /bbb + xx1
      ymin = -0.25D0*ccc**2/bbb + yy1

c-----
c Done
c-----

      Return
      End
