      subroutine matrix
     +
     +   (w,ws
     +   ,ev,v,vc
     +   ,Ma
     +   ,taup
     +   ,alphap
     +   ,cR,cI
     +   ,AR,AI
     +   ,DTR,DTI
     +   )

c---------------------------------
c definition of the secular matrix
c---------------------------------

      Implicit Double Precision (a-h,o-z)

      Dimension AR(4,4),AI(4,4)

      Double Precision Ma

      common/pii/pi,pih,pi2,pis

c---
      AR(1,1) = 2.0D0*w
       AI(1,1) = 0.0D0
      AR(1,2) = 1.0D0
       AI(1,2) = 0.0D0
      AR(1,3) = 1.0D0
       AI(1,3) = 0.0D0
      AR(1,4) = 0.0D0
       AI(1,4) = 0.0D0
c---
      AR(2,1) = vc*w
       AI(2,1) = 0.0D0
      AR(2,2) = w+1.0D0
       AI(2,2) = 0.0D0
      AR(2,3) = v*(w-1.0D0)
       AI(2,3) = 0.0D0
      AR(2,4) = 0.0D0
       AI(2,4) = - 0.5D0*ev
c---
      AR(3,1) =  cR * ws*(1.0D0+v)
       AI(3,1) =  cI * ws*(1.0D0+v) + taup * vc
      AR(3,2) =  cR * ws
       AI(3,2) =  cI * ws + taup
      AR(3,3) = - cR*v*ws
       AI(3,3) = - cI*v*ws + v*taup
      AR(3,4) = 0.0D0
       AI(3,4) = 0.0D0
c---

      AR(4,1) = Ma*w*(1.0D0+v)
       AI(4,1) = 0.0D0
      AR(4,2) = Ma*(1.0D0+w)
       AI(4,2) = 0.0D0
      AR(4,3) = Ma*v*(1.0D0-w)
       AI(4,3) = 0.0D0
      AR(4,4) =  cR*ev
       AI(4,4) = (cI + w/alphap)*ev

c------
c print
c------

c     write (6,*)
c     Do i=1,4
c      write (6,101) (AR(i,j),j=1,4)
c     End Do
c     write (6,*)
c     Do i=1,4
c      write (6,101) (AI(i,j),j=1,4)
c     End Do
c     pause

c---
c determinant
c---

      call Det_44c
     +
     +   (AR,AI
     +   ,DTR,DTI
     +   )

c-----
c Done
c-----

  101 Format (100(1x,F12.8))

      Return
      End
