      subroutine if0
     +
     +  (RL         ! wave length
     +  ,vs1,vs2    ! viscosities
     +  ,rho1,rho2  ! densities
     +  ,gamma      ! surface tension
     +  ,gac        ! accel of gravity
     +  ,si         ! growth rate
     +  )

c-----------------------------------------
c FDLIB
c
c Copyright by C. Pozrikidis, 1999
c All rights reserved.
c
c This program is to be used only under the
c stipulations of the licensing agreement.
c----------------------------------------

c-----------------------------------------
c Instability of the interface between two
c semi-infinite fluids in Stokes flow
c
c Lower fluid is labeled 1
c Upper fluid is labeled 2
c------------------------------------------

      Implicit Double Precision (a-h,o-z)

c----------
c constants
c----------

      pi  = 3.14159 265358 D0
      pi2 = 2.0D0*pi

c--------
c prepare
c--------

      Drho = rho1-rho2

      wn = pi2/RL   ! wave number

c------------
c growth rate
c------------

      si = - 0.5D0*(gac*Drho/wn + wn*gamma)/(vs1+vs2)

c-----
c Done
c-----

      return
      end
