      subroutine crout (n,a,Det)

c-----------------------------------------
c FDLIB
c
c Copyright by C. Pozrikidis, 1999
c All rights reserved.
c
c This program is to be used only under the
c stipulations of the licensing agreement.
c----------------------------------------

c---------------------
c  Crout decomposition
c  and computation of the determinant
c  of a matrix
c
c  Algorithm 2.6.2 of Pozrikidis (1998)
c---------------------

      Implicit Double Precision (a-h,o-z)

      Double Precision l(6,6)

      Dimension  u(6,6),a(6,6)

c------------
c initialize
c-----------

      Do i=1,n
       u(i,i) = 1.0D0
       l(i,1) = a(i,1)
       u(1,i) = a(1,i)/l(1,1)
      End do

c--------------
c perform Crout
c--------------

      Do k=2,n

        Do i=k,n
           sum=0.0D0
           Do m=1,k-1
             sum = sum + l(i,m)*u(m,k)
           End Do
           l(i,k) = a(i,k) - sum
           End Do

           Do j=k+1,n
              sum = 0.0D0
              Do m=1,k-1
                 sum = sum + l(k,m)*u(m,j)
              End Do
           u(k,j) = (a(k,j)-sum)/l(k,k)
           End Do

      End Do

c------------------------
c Compute the determinant
c------------------------

      Det = 1.0D0

      Do i=1,n
       Det = Det*l(i,i)
      End Do

c-----
c Done
c-----

      Return
      End
