      subroutine rayleigh_vel 
     +
     +   (menu,U0,delta,alpha,y
     +   ,U,Up,Upp)

c========================================
c FDLIB
c
c Copyright by C. Pozrikidis, 1999
c All rights reserved
c
c This program is to be used only under the
c stipulations of the licensing agreement
c========================================

c-------------------------------
c Evaluate the velocity (U)
c first derivative (Up)
c and second derivative (Upp)
c at a point y
c
c menu: choice of velocity profile
c U0:   coefficient of the velocity profile
c delta: length scale of the velocity profile
c alpha: velocity profile parameter
c---------------------------

      Implicit Double Precision (a-h,o-z)

c-------
c prepare
c--------

      eta  = y/delta

c-------
c evaluate
c--------

c---
      if(menu.eq.1) then
c---
      
        tmp = exp(-eta**2)
        alphac = 1.0D0-alpha
        U   =  alpha*tanh(eta)    - alphac*tmp
        Up  =  alpha/cosh(eta)**2 + alphac*2.0D0*eta*tmp
        Upp = -alpha*2.0D0*sinh(eta)/cosh(eta)**3 
     +        -alphac*2.0D0*(1.0D0-2.0D0*eta)*tmp

c---
      elseif(menu.eq.2) then
c---

        eps = 0.00001
        U   = 1.0D0/cosh(eta)**2
        U1  = 1.0D0/cosh(eta-eps)**2
        U2  = 1.0D0/cosh(eta+eps)**2
        Up  = (U2-U1)/(2.0*eps)
        Upp = (U2-2*U+U1)/eps**2

c---
      end if
c---

c---
c scale
c---

      Up  =  Up/delta
      Upp = Upp/delta**2

      U   =   U*U0
      Up  =  Up*U0
      Upp = Upp*U0

c-----
c Done
c-----

      return
      end
