      subroutine vs 
     +
     +  (L
     +  ,den2,den1
     +  ,gamma
     +  ,U1,U2,gac
     +  ,cr,ci
     +  ,sr,si
     +  )

c========================================
c FDLIB
c
c Copyright by C. Pozrikidis, 1999
c All rights reserved
c
c This program is to be used only under the
c stipulations of the licensing agreement
c========================================

c------------------------------
c Stability of a vortex sheet
c separating two homogeneous fluids.
c
c An analytical expression for the
c complex phase velocity is given 
c by Pozrikidis (1997, p. 460)
c-----------------------------

      Implicit Double Precision (a-h,o-z)

      Double Precision k,L

c---
c constants
c---

      pi  = 3.14159 265358 D0
      pi2 = 2.0D0*pi

c------------
c wave number
c------------

      k = pi2/L

c---
c radical
c---

      rad = gac*(den2*den2-den1*den1)/k
     +    + k*gamma*(den2+den1)
     +    - den1*den2*(U2-U1)*(U2-U1)

      first = den2*U2+den1*U1
      par   = den1+den2

c---
c complex phase velocity
c---

      if(rad.gt.0) then
       cr = (first+sqrt(rad))/par
       ci = 0.
      else
       cr = first/par
       ci = sqrt(-rad)/par
      end if

c---
c complex growth rate
c---

      sr =  k*cr
      si =  k*ci

c-----
c done
c-----

      return
      end
