      subroutine lvr_sph 
     +
     +  (Iopt
     +  ,x,s
     +  ,x0,s0
     +  ,xc       ! sphere center
     +  ,a        ! sphere radius
     +  ,u,v
     +  ,psi
     +  )

c========================================
c FDLIB
c
c Copyright by C. Pozrikidis, 1999
c All rights reserved
c
c This program is to be used only under the
c stipulations of the licencing agreement
c========================================

c--------------------------------------------------
c Velocity component and Stokes stream function
c due to a line vortex ring
c in the presence of a sphere with center at x = xc
c
c If Iopt.eq.1 the subroutine computed the velocity
c If Iopt.ne.1 the subroutine computed the velocity
c              and the Stokes stream function
c--------------------------------------------------

      Implicit Double Precision (a-h,o-z)

c---
c primary ring
c---

      call lvr_fs 
     +
     +  (Iopt
     +  ,x,s
     +  ,x0,s0
     +  ,u,v
     +  ,psi
     +  )

c---
c image with respect to the sphere
c---

      as  = a**2
      dds = (x0-xc)**2+s0**2
      x0i = xc+as*(x0-xc)/dds
      s0i =    as* s0    /dds

      w0i = -a/sqrt(dds)    ! strength of image ring

      call lvr_fs 
     +
     +  (Iopt
     +  ,x,s
     +  ,x0i,s0i
     +  ,ui,vi
     +  ,psii
     +  )

c---
c add them up
c---

      psi = psi+ w0i*psii

      u = u + w0i* ui
      v = v + w0i*vi

c-----
c done
c-----

      Return
      End
