      subroutine pv_circle
     +
     +  (x,y
     +  ,x0,y0
     +  ,xc,yc    ! circle center
     +  ,a        ! circle radius
     +  ,u,v
     +  )

c-----------------------------------------
c FDLIB
c
c Copyright by C. Pozrikidis, 1999
c All rights reserved
c
c This program is to be used only under the
c stipulations of the licencing agreement
c----------------------------------------

c-----------------------------------------
c Point vortex in the exterior or interior
c of a circular cylinder
c
c SYMBOLS:
c -------
c
c (xc,yc):  coordinate of the circle center
c a:        circle radius
c-----------------------------------------

      Implicit Double Precision (a-h,o-z)

c----------
c constants
c----------

      pi  = 3.14159 265358
      pi2 = 2.0*pi

c--------
c prepare
c--------

      as = a*a

c---------------------
c primary point vortex
c---------------------

      dx  = x-x0
      dy  = y-y0
      rs  = dx*dx+dy*dy
      den = rs*pi2
      u   = -Dy/den
      v   =  Dx/den

c-------------------
c image point vortex
c-------------------

      Dists = (x0-xc)**2+(y0-yc)**2
      x0i   = xc + as*(x0-xc)/Dists   ! image
      y0i   = yc + as*(y0-yc)/Dists   ! image

      dx  = x-x0i
      dy  = y-y0i
      rs  = dx*dx+dy*dy
      den = rs*pi2
      u   = u + Dy/den
      v   = v - Dx/den

c-----
c Done
c-----

      return
      end
