      subroutine pv_www
     +
     + (x,y
     + ,x0,y0
     + ,wall1
     + ,wall2
     + ,wall3
     + ,u,v
     + )

c========================================
c FDLIB
c
c Copyright by C. Pozrikidis, 1999
c All rights reserved
c
c This program is to be used only under the
c stipulations of the licencing agreement
c========================================

c-------------------------------------------------
c A point vortex in a semi-infintie strip confined
c between two parallel walls located at
c x = wall1 and x = wall2
c and a perpendicular wall located at y = wall3
c-------------------------------------------------

      Implicit Double Precision (a-h,o-z)

c---
c  constants
c---

      pi  = 3.14159 265358D0
      pi2 = 2.0D0*pi

c---
c prepare
c---

      h  = wall2-wall1
      wn = pi2/(2.0D0*h)    ! wave number
      cf = 1.0D0/(4.0D0*h)

c---
c effect of vertical walls
c---

      dx  = x-x0
      dxi = x-2.0D0*wall1+x0

      A  = wn*dx
      Ai = wn*dxi

      dy = y-y0
      B  = wn*dy
      C  = cosh(B)
      D  = C-cos(A)
      Di = C-cos(Ai)

      u = -cf*sinh(B)*(1.0D0/D-1.0D0/Di)
      v =  cf*(sin(A)/D-sin(Ai)/Di)

c---
c effect of horizontal wall
c---

      dy = y-2.0D0*wall3+y0
      B  = wn*dy
      C  = cosh(B)
      D  = C-cos(A)
      Di = C-cos(Ai)

      u = u + cf*sinh(B)*(1.0D0/D-1.0D0/Di)
      v = v - cf*(sin(A)/D-sin(Ai)/Di)

c---
c done
c---

      return
      end
