      subroutine pvm_pr_vel 
     +
     +  (Npv
     +  ,x,y,c
     +  ,RL
     +  ,u,v
     +  )

c-----------------------------------------
c FDLIB
c
c Copyright by C. Pozrikidis, 1999
c All rights reserved.
c
c This program is to be used only under the
c stipulations of the licensing agreement.
c----------------------------------------

c---------------------------------------------
c Velocity induced by a periodic collection of 
c point vortices
c---------------------------------------------

      Implicit Double Precision (a-h,o-z)

      Dimension x(-10:100),y(-10:100),c(-10:100)
      Dimension u(-10:100),v(-10:100)

c----------
c constants
c----------

      pi  = 3.14159265358D0
      pi2 = 2.0D0*pi

c---
c compute the induced velocity
c---

      Do 66 i=1,Npv   ! loop over point vortices

c---
c First compute velocity at point (x0,y0)
c induced by all other point vortices
c---

        x0 = x(i)
        y0 = y(i)

        u0 = 0.0D0
        v0 = 0.0D0

        Do 1 j=1,Npv

        if(i.ne.j) then  ! skip the self-induced velocity

         xx = x(j)
         yy = y(j)

         call pv_pr
     +
     +     (x0,y0
     +     ,x(j),y(j)
     +     ,RL
     +     ,upv,vpv
     +     )

         u0 = u0 + c(j)*upv
         v0 = v0 + c(j)*vpv

        end if

   1   Continue

c---
c self-induced velocity is zero
c---

       u(i) = u0
       v(i) = v0

   66  Continue
       
c-----
c Done
c-----

      Return
      End
