      subroutine ell_int (RK2,F,E)

c-----------------------------------------
c Copyright by C. Pozrikidis, 1999
c All rights reserved.
c
c This program is to be used only under the
c stipulations of the licencing agreement.
c----------------------------------------

c-------------------------------------------
c  Evaluation of complete elliptic integrals
c  of the first and second kind
c
c  F:	first kind
c  E:	second kind
c-------------------------------------------

c------------------------------------------------
c This program accompanies the book:
c
c C. Pozrikidis
c
c Numerical Computation in Science and Engineering
c
c Oxford University Press
c
c 1998
c------------------------------------------------

      Implicit Double Precision (a-h,o-z)

      Parameter (acc=0.000000001)

c---
c constants
c---

      pi  = 3.14159 265358 
      pih = 0.5*pi
      
c---
c launching
c---

      RK = sqrt(RK2)
      F  = pih
      E  = 1.0
      G  = 1.0
      B  = RK
 
  1   Continue

c     Do 99 while (abs(D).GT.acc)

      C = sqrt(1.0-B**2)
      B = (1.0-C)/(1.0+C)
      D = F*B
      F = F+D
      G = 0.5*G*B
      E = E+G

c     End Do

      If(abs(D).gt.acc) GO TO 1

      E=F*(1.0-0.5*RK2*E)
 
      Return
      End
