%---
clear all
close all
%---

%=====================================
% Generate and plot the solution of the
% Falkner-Scan boundary layer equation
%=====================================

Nstep = 128;
etamax = 10.0;

deta = etamax/Nstep;

figure(1)
hold on

%===
for repeat=1:6
%===

eta = 0.0;
x(1)= 0.0; x(2) = 0.0;

if(repeat==1)
 m=1.5; x(3)=1.49138;
elseif(repeat==2)
 m=1.0; x(3)=1.2314;
elseif(repeat==3)
 m=0.25; x(3)=0.675;
elseif(repeat==4)
 m=0.176; x(3)=0.5936;
elseif(repeat==5)
 m=-0.0904; x(3)=0.0;
else
 m=0.0; x(3)=0.332;
end

xplot(1)=eta;
yplot1(1)=x(1);
yplot2(1)=x(2);
yplot3(1)=x(3);

%---
% integrate by RK2
%---

%---
for i=2:Nstep+1
  xp = falskan_ode(m,x);
   for j=1:3
    xsave(j) = x(j);
    xpsave(j) = xp(j);
    x(j) = x(j) + xp(j)*deta;
   end
   eta = eta + deta;
   xp = falskan_ode(m,x);
   for j=1:3
     x(j) = xsave(j) + 0.5*(xpsave(j)+xp(j))*deta;
   end
   xplot(i)=eta;
   yplot1(i)=x(1);
   yplot2(i)=x(2);
   yplot3(i)=x(3);
end

%---
% plotting
%---

%plot(yplot1,xplot,'k--')
if(repeat==6)
plot(yplot2,xplot,'--k')
elseif(repeat==1)
plot(yplot2,xplot,':k')
else
plot(yplot2,xplot,'k')
end
%plot(yplot3,xplot,'k:')

%===
end  % over repeat
%===

xlabel('u_x/U_x','fontsize',15)
ylabel('\eta','fontsize',15)
set(gca,'fontsize',15)
axis([0 1.2 0 6])
box
