      subroutine thomas 
     +
     +   (N
     +   ,a,b,c
     +   ,s
     +   ,x
     +   )

c=======================================
c FDLIB, BEMLIB
c
c Copyright by C. Pozrikidis, 1999
c All rights reserved
c
c This program is to be used only under the
c stipulations of the licensing agreement
c=======================================

c------------------------------------------
c Thomas algorithm for solving
c a tridiagonal system of linear euqations
c 
c tol: tolerance
c------------------------------------------

      Implicit Double Precision (a-h,o-z)

      Dimension   a(129),b(129),c(129)
      Dimension rhs(129),x(129)
      Dimension d(129),y(129)

      Parameter (tol=0.000000001)

c------------------------------
c reduction to upper bidiagonal
c------------------------------

      d(1) = b(1)/a(1)
      y(1) = rhs(1)/a(1)

      Do i=1,N-2
       i1 = i+1
       den   = a(i1)-c(i1)*d(i)
       d(i1) = b(i1)/den
       y(i1) = (rhs(i1)-c(i1)*y(i))/den
      End Do

      den = a(N)-c(N)*d(N-1)
      y(N) = (rhs(N)-c(N)*y(N-1))/den

c------------------
c back substitution
c------------------

      x(N) = y(N)

      Do i=Na,1,-1
        x(i)= y(i)-d(i)*x(i+1)
      End Do

c-----------------------
c Verification and alarm
c (optional)
c-----------------------

      Res = s(1)-a(1)*x(1)-b(1)*x(2)

      if(abs(Res).gt.tol) then
          write (6,*) 
          write (6,*) " Thomas: alarm"
          write (6,*) 
      end if

      Do i=2,N-1
        Res = s(i)-c(i)*x(i-1)-a(i)*x(i)-b(i)*x(i+1)
        if(abs(Res).gt.tol) then
          write (6,*) 
          write (6,*) " Thomas: alarm"
          write (6,*) 
        end if
      End Do

      Res = s(N)-c(N)*x(N-1)-a(N)*x(N)

      if(abs(Res).gt.tol) then
          write (6,*) 
          write (6,*) " Thomas: alarm"
          write (6,*) 
      end if

c-----
c Done
c-----

 100  Format (1x,f15.10)

      Return
      End
